
SOURCE_FILE = 'ripper.y'
HEADER_FILE = 'ripper.h'
INTERF_FILE = 'ripper.rb'
DISPID_FILE = 'dispids'


list = nil
File.open( SOURCE_FILE ) {|f|
    list = f.collect {|line|
        m = /dispatch\d\((\w+)/.match(line) and m[1]
    }.compact.push('scan').sort.uniq
}


File.open( DISPID_FILE + '.h', 'w' ) {|f|
    list.each do |i|
      f.puts "static ID rip_id_#{i};"
    end
}

File.open( DISPID_FILE + '.c', 'w' ) {|f|
    f.print <<'-'
static void
rip_init_dispatch_ids()
{
-
    list.each do |i|
      f.puts %Q!    rip_id_#{i} =\trb_intern("on__#{i}");!
    end
    ;f.print <<'-'
}
-
}

File.open( INTERF_FILE, 'w' ) {|f|
    f.print <<HEADER
#
# This file is automatically generated from ripper.y.
# DO NOT MODIFY!!!!!!
#

require 'ripper.so'

class Ripper
HEADER
    list.each do |name|
      f.print <<METHOD
  def on__#{name}( *args )
    args[0]
  end
METHOD
    end
    f.puts 'end'
}
